# wxHVScrolledWindow Class Reference
[Miscellaneous Windows]

`#include <wx/vscroll.h>`

Inheritance diagram for wxHVScrolledWindow:
[legend]

## Detailed Description

This window inherits all functionality of both vertical and horizontal, variable scrolled windows.

It automatically handles everything needed to scroll both axis simultaneously with both variable row heights and variable column widths.

In any case, this is a generalization of wxScrolled which can be only used when all rows and columns are the same size. It lacks some other wxScrolled features however, notably it can't scroll specific pixel sizes of the window or its exact client area size.

To use this class, you must derive from it and implement both the OnGetRowHeight() and OnGetColumnWidth() pure virtual methods to let the base class know how many rows and columns it should display. You also need to set the total rows and columns the window contains, but from that moment on the scrolling is handled entirely by wxHVScrolledWindow. You only need to draw the visible part of contents in your `OnPaint()` method as usual. You should use GetVisibleBegin() and GetVisibleEnd() to select the lines to display. Note that the device context origin is not shifted so the first visible row and column always appear at the point (0, 0) in physical as well as logical coordinates.

##

Library: wxCore

Category: Miscellaneous Windows

See also:
  wxHScrolledWindow, wxVScrolledWindow

## Public Member Functions
| wxHVScrolledWindow ()
| Default constructor, you must call Create() later.
| wxHVScrolledWindow (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| This is the normal constructor, no need to call Create() after using this constructor.
bool | Create (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Same as the non-default constructor, but returns a status code: true if ok, false if the window couldn't be created.

List of all members.

## Constructor & Destructor Documentation

wxHVScrolledWindow::wxHVScrolledWindow | ( |  | ) |

Default constructor, you must call Create() later.

wxHVScrolledWindow::wxHVScrolledWindow | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0`,
|  | const wxString & | name = `wxPanelNameStr` |
| ) |  |  |

This is the normal constructor, no need to call Create() after using this constructor.

Note:
  `wxHSCROLL` and `wxVSCROLL` are always automatically added to the style, there is no need to specify it explicitly.

Parameters:

  | parent | The parent window, must not be NULL.
  | id | The identifier of this window, wxID_ANY by default.
  | pos | The initial window position.
  | size | The initial window size.
  | style | The window style. There are no special style bits defined for this class.
  | name | The name for this window; usually not used.

## Member Function Documentation

bool wxHVScrolledWindow::Create | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0`,
|  | const wxString & | name = `wxPanelNameStr` |
| ) |  |  |

Same as the non-default constructor, but returns a status code: true if ok, false if the window couldn't be created.

Just as with the constructor, the `wxHSCROLL` and `wxVSCROLL` styles are always used, there is no need to specify them explicitly.

Reimplemented from wxPanel.

|  | [ top ]